Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -2545,241 +2096,183 @@
 
 !
-!-- Set output format string (used in header)
-    SELECT CASE ( netcdf_data_format )
-       CASE ( 1 )
-          netcdf_data_format_string = 'netCDF classic'
-       CASE ( 2 )
-          netcdf_data_format_string = 'netCDF 64bit offset'
-       CASE ( 3 )
-          netcdf_data_format_string = 'netCDF4/HDF5'
-       CASE ( 4 )
-          netcdf_data_format_string = 'netCDF4/HDF5 classic'
-       CASE ( 5 )
-          netcdf_data_format_string = 'parallel netCDF4/HDF5'
-       CASE ( 6 )
-          netcdf_data_format_string = 'parallel netCDF4/HDF5 classic'
-
-    END SELECT
-
-!
-!-- Check mask conditions
-    DO mid = 1, max_masks
-       IF ( data_output_masks(mid,1) /= ' '  .OR.  data_output_masks_user(mid,1) /= ' ' )  THEN
-          masks = masks + 1
-       ENDIF
-    ENDDO
-
-    IF ( masks < 0  .OR.  masks > max_masks )  THEN
-       WRITE( message_string, * )  'illegal value: masks must be >= 0 and ', '<= ', max_masks,     &
-              ' (=max_masks)'
-       CALL message( 'check_parameters', 'PA0325', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( masks > 0 )  THEN
-       mask_scale(1) = mask_scale_x
-       mask_scale(2) = mask_scale_y
-       mask_scale(3) = mask_scale_z
-       IF ( ANY( mask_scale <= 0.0_wp ) )  THEN
-          WRITE( message_string, * )  'illegal value: mask_scale_x, mask_scale_y and mask_scale_z',&
-                 'must be > 0.0'
-          CALL message( 'check_parameters', 'PA0326', 1, 2, 0, 6, 0 )
-       ENDIF
-!
-!--    Generate masks for masked data output.
-!--    Parallel netcdf output is not tested so far for masked data, hence netcdf_data_format is
-!--    switched back to non-parallel output.
-       netcdf_data_format_save = netcdf_data_format
-       IF ( netcdf_data_format > 4 )  THEN
-          IF ( netcdf_data_format == 5 ) netcdf_data_format = 3
-          IF ( netcdf_data_format == 6 ) netcdf_data_format = 4
-          message_string = 'netCDF file formats '// '5 (parallel netCDF 4) and 6 (parallel ' //    &
-                           'netCDF 4 Classic model) & are currently not supported (not yet ' //    &
-                           'tested) for masked data. &Using respective non-parallel' //            &
-                           ' output for masked data.'
-          CALL message( 'check_parameters', 'PA0383', 0, 0, 0, 6, 0 )
-       ENDIF
-       CALL init_masks
-       netcdf_data_format = netcdf_data_format_save
-    ENDIF
-
-!
-!-- Check the NetCDF data format
-    IF ( netcdf_data_format > 2 )  THEN
-#if defined( __netcdf4 )
-       CONTINUE
-#else
-       message_string = 'netCDF: netCDF4 format requested but no ' //                              &
-                        'cpp-directive __netcdf4 given & switch back to 64-bit offset format'
-       CALL message( 'check_parameters', 'PA0171', 0, 1, 0, 6, 0 )
-       netcdf_data_format = 2
-#endif
-    ENDIF
-    IF ( netcdf_data_format > 4 )  THEN
-#if defined( __netcdf4 ) && defined( __netcdf4_parallel )
-       CONTINUE
-#else
-       message_string = 'netCDF: netCDF4 parallel output requested but no ' //                     &
-                        'cpp-directive __netcdf4_parallel given & switch ' //                      &
-                        'back to netCDF4 non-parallel output'
-       CALL message( 'check_parameters', 'PA0099', 0, 1, 0, 6, 0 )
-       netcdf_data_format = netcdf_data_format - 2
-#endif
-    ENDIF
-
-!
-!-- Calculate fixed number of output time levels for parallel netcdf output.
-!-- The time dimension has to be defined as limited for parallel output, because otherwise the I/O
-!-- performance drops significantly.
-    IF ( netcdf_data_format > 4 )  THEN
-
-!
-!--    Check if any of the follwoing data output interval is 0.0s, which is not allowed for parallel
-!--    output.
-       CALL check_dt_do( dt_do3d,           'dt_do3d'           )
-       CALL check_dt_do( dt_do2d_xy,        'dt_do2d_xy'        )
-       CALL check_dt_do( dt_do2d_xz,        'dt_do2d_xz'        )
-       CALL check_dt_do( dt_do2d_yz,        'dt_do2d_yz'        )
-       CALL check_dt_do( dt_data_output_av, 'dt_data_output_av' )
-
-!--    Set needed time levels (ntdim) to saved time levels + to be saved time levels.
-       ntdim_3d(0) = do3d_time_count(0) + CEILING(                                                 &
-                     ( end_time - MAX(                                                             &
-                         MERGE( skip_time_do3d, skip_time_do3d + spinup_time,                      &
-                                data_output_during_spinup ),                                       &
-                         simulated_time_at_begin )                                                 &
-                     ) / dt_do3d )
-       IF ( do3d_at_begin ) ntdim_3d(0) = ntdim_3d(0) + 1
-
-       ntdim_3d(1) = do3d_time_count(1) + CEILING(                                                 &
-                     ( end_time - MAX(                                                             &
-                         MERGE( skip_time_data_output_av, skip_time_data_output_av + spinup_time,  &
-                                data_output_during_spinup ),                                       &
-                         simulated_time_at_begin )                                                 &
-                     ) / dt_data_output_av )
-
-       ntdim_2d_xy(0) = do2d_xy_time_count(0) + CEILING(                                           &
-                        ( end_time - MAX(                                                          &
-                            MERGE( skip_time_do2d_xy, skip_time_do2d_xy + spinup_time,             &
-                                   data_output_during_spinup ),                                    &
-                            simulated_time_at_begin )                                              &
-                        ) / dt_do2d_xy )
-
-       ntdim_2d_xz(0) = do2d_xz_time_count(0) + CEILING(                                           &
-                        ( end_time - MAX(                                                          &
-                            MERGE( skip_time_do2d_xz, skip_time_do2d_xz + spinup_time,             &
-                                   data_output_during_spinup ),                                    &
-                            simulated_time_at_begin )                                              &
-                        ) / dt_do2d_xz )
-
-       ntdim_2d_yz(0) = do2d_yz_time_count(0) + CEILING(                                           &
-                        ( end_time - MAX(                                                          &
-                            MERGE( skip_time_do2d_yz, skip_time_do2d_yz + spinup_time,             &
-                                   data_output_during_spinup ),                                    &
-                            simulated_time_at_begin )                                              &
-                        ) / dt_do2d_yz )
-
-       IF ( do2d_at_begin )  THEN
-          ntdim_2d_xy(0) = ntdim_2d_xy(0) + 1
-          ntdim_2d_xz(0) = ntdim_2d_xz(0) + 1
-          ntdim_2d_yz(0) = ntdim_2d_yz(0) + 1
-       ENDIF
-!
-!--    Please note, for averaged 2D data skip_time_data_output_av is the relavant output control
-!--    parameter.
-       ntdim_2d_xy(1) = do2d_xy_time_count(1) + CEILING(                                           &
-                        ( end_time - MAX( MERGE( skip_time_data_output_av,                         &
-                                                 skip_time_data_output_av + spinup_time,           &
-                                                 data_output_during_spinup ),                      &
-                                          simulated_time_at_begin )                                &
-                        ) / dt_data_output_av )
-
-       ntdim_2d_xz(1) = do2d_xz_time_count(1) + CEILING(                                           &
-                        ( end_time - MAX( MERGE( skip_time_data_output_av,                         &
-                                                 skip_time_data_output_av + spinup_time,           &
-                                                 data_output_during_spinup ),                      &
-                                          simulated_time_at_begin )                                &
-                        ) / dt_data_output_av )
-
-       ntdim_2d_yz(1) = do2d_yz_time_count(1) + CEILING(                                           &
-                        ( end_time - MAX( MERGE( skip_time_data_output_av,                         &
-                                                 skip_time_data_output_av + spinup_time,           &
-                                                 data_output_during_spinup ),                      &
-                                          simulated_time_at_begin )                                &
-                        ) / dt_data_output_av )
-
-    ENDIF
+!-- Determine and check accuracy for compressed 3D plot output
+    IF ( do3d_compress )  THEN
+!
+!--    Compression only permissible on T3E machines
+       IF ( host(1:3) /= 't3e' )  THEN
+          IF ( myid == 0 )  THEN
+             PRINT*, '+++ check_parameters: do3d_compress = .TRUE. not allow', &
+                          'ed on host "', TRIM( host ), '"'
+          ENDIF
+          CALL local_stop
+       ENDIF
+
+       i = 1
+       DO  WHILE ( do3d_comp_prec(i) /= ' ' )
+
+          ilen = LEN_TRIM( do3d_comp_prec(i) )
+          IF ( LLT( do3d_comp_prec(i)(ilen:ilen), '0' ) .OR. &
+               LGT( do3d_comp_prec(i)(ilen:ilen), '9' ) )  THEN
+             IF ( myid == 0 )  THEN
+                PRINT*, '+++ check_parameters: illegal precision: ', &
+                        'do3d_comp_prec(', i, ')="', TRIM(do3d_comp_prec(i)),'"'
+             ENDIF
+             CALL local_stop
+          ENDIF
+
+          prec = IACHAR( do3d_comp_prec(i)(ilen:ilen) ) - IACHAR( '0' )
+          var = do3d_comp_prec(i)(1:ilen-1)
+
+          SELECT CASE ( var )
+
+             CASE ( 'u' )
+                j = 1
+             CASE ( 'v' )
+                j = 2
+             CASE ( 'w' )
+                j = 3
+             CASE ( 'p' )
+                j = 4
+             CASE ( 'pt' )
+                j = 5
+
+             CASE DEFAULT
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters: unknown variable in ', &
+                               'assignment'
+                   PRINT*, '    do3d_comp_prec(', i, ')="', &
+                           TRIM( do3d_comp_prec(i) ),'"'
+                ENDIF
+                CALL local_stop                
+
+          END SELECT
+
+          plot_3d_precision(j)%precision = prec
+          i = i + 1
+
+       ENDDO
+    ENDIF
+
+!
+!-- Check the data output format(s)
+    IF ( data_output_format(1) == ' ' )  THEN
+!
+!--    Default value
+       netcdf_output = .TRUE.
+    ELSE
+       i = 1
+       DO  WHILE ( data_output_format(i) /= ' ' )
+
+          SELECT CASE ( data_output_format(i) )
+
+             CASE ( 'netcdf' )
+                netcdf_output = .TRUE.
+             CASE ( 'iso2d' )
+                iso2d_output  = .TRUE.
+             CASE ( 'profil' )
+                profil_output = .TRUE.
+             CASE ( 'avs' )
+                avs_output    = .TRUE.
+
+             CASE DEFAULT
+                IF ( myid == 0 )  THEN
+                   PRINT*, '+++ check_parameters:'
+                   PRINT*, '    unknown value for data_output_format "', &
+                                TRIM( data_output_format(i) ),'"'
+                ENDIF
+                CALL local_stop                
+
+          END SELECT
+
+          i = i + 1
+          IF ( i > 10 )  EXIT
+
+       ENDDO
+
+    ENDIF
+
+!
+!-- Check netcdf precison
+    ldum = .FALSE.
+    CALL define_netcdf_header( 'ch', ldum, 0 )
 
 !
 !-- Check, whether a constant diffusion coefficient shall be used
-    IF ( km_constant /= -1.0_wp )  THEN
-       IF ( km_constant < 0.0_wp )  THEN
-          WRITE( message_string, * )  'km_constant = ', km_constant, ' < 0.0'
-          CALL message( 'check_parameters', 'PA0121', 1, 2, 0, 6, 0 )
+    IF ( km_constant /= -1.0 )  THEN
+       IF ( km_constant < 0.0 )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters:  km_constant=', &
+                                    km_constant, ' < 0.0'
+          CALL local_stop
        ELSE
-          IF ( prandtl_number < 0.0_wp )  THEN
-             WRITE( message_string, * )  'prandtl_number = ', prandtl_number, ' < 0.0'
-             CALL message( 'check_parameters', 'PA0122', 1, 2, 0, 6, 0 )
+          IF ( prandtl_number < 0.0 )  THEN
+             IF ( myid == 0 )  PRINT*,'+++ check_parameters:  prandtl_number=',&
+                                      prandtl_number, ' < 0.0'
+             CALL local_stop
           ENDIF
           constant_diffusion = .TRUE.
 
-          IF ( constant_flux_layer )  THEN
-             message_string = 'constant_flux_layer is not allowed with fixed value of km'
-             CALL message( 'check_parameters', 'PA0123', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDIF
-    ENDIF
-
-!
-!-- In case of non-cyclic lateral boundaries and a damping layer for the potential temperature,
-!-- check the width of the damping layer
+          IF ( prandtl_layer )  THEN
+             IF ( myid == 0 )  PRINT*, '+++ check_parameters:  prandtl_layer ',&
+                                       'is not allowed with fixed value of km'
+             CALL local_stop
+          ENDIF
+       ENDIF
+    ENDIF
+
+!
+!-- In case of non-cyclic lateral boundaries, set the default maximum value
+!-- for the horizontal diffusivity used within the outflow damping layer,
+!-- and check/set the width of the damping layer
     IF ( bc_lr /= 'cyclic' ) THEN
-       IF ( pt_damping_width < 0.0_wp  .OR.  pt_damping_width > REAL( (nx+1) * dx ) )  THEN
-          message_string = 'pt_damping_width out of range'
-          CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
+       IF ( km_damp_max == -1.0 )  THEN
+          km_damp_max = 0.5 * dx
+       ENDIF
+       IF ( outflow_damping_width == -1.0 )  THEN
+          outflow_damping_width = MIN( 20, nx/2 )
+       ENDIF
+       IF ( outflow_damping_width <= 0  .OR.  outflow_damping_width > nx )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: outflow_damping w',&
+                                    'idth out of range'
+          CALL local_stop
        ENDIF
     ENDIF
 
     IF ( bc_ns /= 'cyclic' )  THEN
-       IF ( pt_damping_width < 0.0_wp  .OR.  pt_damping_width > REAL( (ny+1) * dy ) )  THEN
-          message_string = 'pt_damping_width out of range'
-          CALL message( 'check_parameters', 'PA0124', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-!
-!-- Check value range for zeta = z/L
-    IF ( zeta_min >= zeta_max )  THEN
-       WRITE( message_string, * )  'zeta_min = ', zeta_min, ' must be less ', 'than zeta_max = ',  &
-              zeta_max
-       CALL message( 'check_parameters', 'PA0125', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check random generator
-    IF ( (random_generator /= 'system-specific'      .AND.                                         &
-          random_generator /= 'random-parallel'   )  .AND.                                         &
-          random_generator /= 'numerical-recipes' )  THEN
-       message_string = 'unknown random generator: random_generator = "' //                        &
-                        TRIM( random_generator ) // '"'
-       CALL message( 'check_parameters', 'PA0135', 1, 2, 0, 6, 0 )
+       IF ( km_damp_max == -1.0 )  THEN
+          km_damp_max = 0.5 * dy
+       ENDIF
+       IF ( outflow_damping_width == -1.0 )  THEN
+          outflow_damping_width = MIN( 20, ny/2 )
+       ENDIF
+       IF ( outflow_damping_width <= 0  .OR.  outflow_damping_width > ny )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: outflow_damping w',&
+                                    'idth out of range'
+          CALL local_stop
+       ENDIF
+    ENDIF
+
+!
+!-- Check value range for rif
+    IF ( rif_min >= rif_max )  THEN
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  rif_min=', rif_min, &
+                                 ' must be less than rif_max=', rif_max
+       CALL local_stop
     ENDIF
 
 !
 !-- Determine upper and lower hight level indices for random perturbations
-    IF ( disturbance_level_b == -9999999.9_wp )  THEN
-       IF ( ocean_mode )  THEN
-          disturbance_level_b     = zu((nzt*2)/3)
-          disturbance_level_ind_b = ( nzt * 2 ) / 3
-       ELSE
-          disturbance_level_b     = zu(nzb+3)
-          disturbance_level_ind_b = nzb + 3
-       ENDIF
+    IF ( disturbance_level_b == -1.0 )  THEN
+       disturbance_level_b     = zu(nzb+3)
+       disturbance_level_ind_b = nzb + 3
     ELSEIF ( disturbance_level_b < zu(3) )  THEN
-       WRITE( message_string, * )  'disturbance_level_b = ', disturbance_level_b, ' must be >= ',  &
-              zu(3), '(zu(3))'
-       CALL message( 'check_parameters', 'PA0126', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  disturbance_level_b=',&
+                                 disturbance_level_b, ' must be >= ',zu(3),    &
+                                 '(zu(3))'
+       CALL local_stop
     ELSEIF ( disturbance_level_b > zu(nzt-2) )  THEN
-       WRITE( message_string, * )  'disturbance_level_b = ', disturbance_level_b, ' must be <= ',  &
-              zu(nzt-2), '(zu(nzt-2))'
-       CALL message( 'check_parameters', 'PA0127', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  disturbance_level_b=',&
+                                 disturbance_level_b, ' must be <= ',zu(nzt-2),&
+                                 '(zu(nzt-2))'
+       CALL local_stop
     ELSE
        DO  k = 3, nzt-2
@@ -2791,20 +2284,17 @@
     ENDIF
 
-    IF ( disturbance_level_t == -9999999.9_wp )  THEN
-       IF ( ocean_mode )  THEN
-          disturbance_level_t     = zu(nzt-3)
-          disturbance_level_ind_t = nzt - 3
-       ELSE
-          disturbance_level_t     = zu(nzt/3)
-          disturbance_level_ind_t = nzt / 3
-       ENDIF
+    IF ( disturbance_level_t == -1.0 )  THEN
+       disturbance_level_t     = zu(nzt/3)
+       disturbance_level_ind_t = nzt / 3
     ELSEIF ( disturbance_level_t > zu(nzt-2) )  THEN
-       WRITE( message_string, * )  'disturbance_level_t = ', disturbance_level_t, ' must be <= ',  &
-              zu(nzt-2), '(zu(nzt-2))'
-       CALL message( 'check_parameters', 'PA0128', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  disturbance_level_t=',&
+                                 disturbance_level_t, ' must be <= ',zu(nzt-2),&
+                                 '(zu(nzt-2))'
+       CALL local_stop
     ELSEIF ( disturbance_level_t < disturbance_level_b )  THEN
-       WRITE( message_string, * )  'disturbance_level_t = ', disturbance_level_t,                  &
-             ' must be >= disturbance_level_b = ', disturbance_level_b
-       CALL message( 'check_parameters', 'PA0129', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  disturbance_level_t=',&
+                                 disturbance_level_t, ' must be >= ',          &
+                                 'disturbance_level_b=', disturbance_level_b
+       CALL local_stop
     ELSE
        DO  k = 3, nzt-2
@@ -2818,30 +2308,40 @@
 !
 !-- Check again whether the levels determined this way are ok.
-!-- Error may occur at automatic determination and too few grid points in z-direction.
+!-- Error may occur at automatic determination and too few grid points in
+!-- z-direction.
     IF ( disturbance_level_ind_t < disturbance_level_ind_b )  THEN
-       WRITE( message_string, * )  'disturbance_level_ind_t = ', disturbance_level_ind_t,          &
-              ' must be >= ', 'disturbance_level_ind_b = ', disturbance_level_ind_b
-       CALL message( 'check_parameters', 'PA0130', 1, 2, 0, 6, 0 )
+       IF ( myid == 0 )  PRINT*, '+++ check_parameters:  ',                &
+                                 'disturbance_level_ind_t=',               &
+                                 disturbance_level_ind_t, ' must be >= ',  &
+                                 'disturbance_level_ind_b=',               &
+                                 disturbance_level_ind_b
+       CALL local_stop
     ENDIF
 
 !
 !-- Determine the horizontal index range for random perturbations.
-!-- In case of non-cyclic horizontal boundaries, no perturbations are imposed near the inflow and
-!-- the perturbation area is further limited to ...(1) after the initial phase of the flow.
-
+!-- In case of non-cyclic horizontal boundaries, no perturbations are imposed
+!-- near the inflow and the perturbation area is further limited to ...(1)
+!-- after the initial phase of the flow.
+    dist_nxl = 0;  dist_nxr = nx
+    dist_nys = 0;  dist_nyn = ny
     IF ( bc_lr /= 'cyclic' )  THEN
        IF ( inflow_disturbance_begin == -1 )  THEN
           inflow_disturbance_begin = MIN( 10, nx/2 )
        ENDIF
-       IF ( inflow_disturbance_begin < 0  .OR.  inflow_disturbance_begin > nx )  THEN
-          message_string = 'inflow_disturbance_begin out of range'
-          CALL message( 'check_parameters', 'PA0131', 1, 2, 0, 6, 0 )
+       IF ( inflow_disturbance_begin < 0  .OR.  inflow_disturbance_begin > nx )&
+       THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: inflow_disturbance',&
+                                    '_begin out of range'
+          CALL local_stop
        ENDIF
        IF ( inflow_disturbance_end == -1 )  THEN
           inflow_disturbance_end = MIN( 100, 3*nx/4 )
        ENDIF
-       IF ( inflow_disturbance_end < 0  .OR.  inflow_disturbance_end > nx )  THEN
-          message_string = 'inflow_disturbance_end out of range'
-          CALL message( 'check_parameters', 'PA0132', 1, 2, 0, 6, 0 )
+       IF ( inflow_disturbance_end < 0  .OR.  inflow_disturbance_end > nx )    &
+       THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: inflow_disturbance',&
+                                    '_end out of range'
+          CALL local_stop
        ENDIF
     ELSEIF ( bc_ns /= 'cyclic' )  THEN
@@ -2849,125 +2349,45 @@
           inflow_disturbance_begin = MIN( 10, ny/2 )
        ENDIF
-       IF ( inflow_disturbance_begin < 0  .OR.  inflow_disturbance_begin > ny )  THEN
-          message_string = 'inflow_disturbance_begin out of range'
-          CALL message( 'check_parameters', 'PA0131', 1, 2, 0, 6, 0 )
+       IF ( inflow_disturbance_begin < 0  .OR.  inflow_disturbance_begin > ny )&
+       THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: inflow_disturbance',&
+                                    '_begin out of range'
+          CALL local_stop
        ENDIF
        IF ( inflow_disturbance_end == -1 )  THEN
           inflow_disturbance_end = MIN( 100, 3*ny/4 )
        ENDIF
-       IF ( inflow_disturbance_end < 0  .OR.  inflow_disturbance_end > ny )  THEN
-          message_string = 'inflow_disturbance_end out of range'
-          CALL message( 'check_parameters', 'PA0132', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-    IF ( random_generator == 'random-parallel' )  THEN
-       dist_nxl = nxl;  dist_nxr = nxr
-       dist_nys = nys;  dist_nyn = nyn
-       IF ( bc_lr == 'radiation/dirichlet' )  THEN
-          dist_nxr    = MIN( nx - inflow_disturbance_begin, nxr )
-          dist_nxl(1) = MAX( nx - inflow_disturbance_end, nxl )
-       ELSEIF ( bc_lr == 'dirichlet/radiation' )  THEN
-          dist_nxl    = MAX( inflow_disturbance_begin, nxl )
-          dist_nxr(1) = MIN( inflow_disturbance_end, nxr )
-       ELSEIF ( bc_lr == 'nested'  .OR.  bc_lr == 'nesting_offline' )  THEN
-          dist_nxl    = MAX( inflow_disturbance_begin, nxl )
-          dist_nxr    = MIN( nx - inflow_disturbance_begin, nxr )
-       ENDIF
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
-          dist_nyn    = MIN( ny - inflow_disturbance_begin, nyn )
-          dist_nys(1) = MAX( ny - inflow_disturbance_end, nys )
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-          dist_nys    = MAX( inflow_disturbance_begin, nys )
-          dist_nyn(1) = MIN( inflow_disturbance_end, nyn )
-       ELSEIF ( bc_ns == 'nested'  .OR.  bc_ns == 'nesting_offline' )  THEN
-          dist_nys    = MAX( inflow_disturbance_begin, nys )
-          dist_nyn    = MIN( ny - inflow_disturbance_begin, nyn )
-       ENDIF
-    ELSE
-       dist_nxl = 0;  dist_nxr = nx
-       dist_nys = 0;  dist_nyn = ny
-       IF ( bc_lr == 'radiation/dirichlet' )  THEN
-          dist_nxr    = nx - inflow_disturbance_begin
-          dist_nxl(1) = nx - inflow_disturbance_end
-       ELSEIF ( bc_lr == 'dirichlet/radiation' )  THEN
-          dist_nxl    = inflow_disturbance_begin
-          dist_nxr(1) = inflow_disturbance_end
-       ELSEIF ( bc_lr == 'nested'  .OR.  bc_lr == 'nesting_offline' )  THEN
-          dist_nxr    = nx - inflow_disturbance_begin
-          dist_nxl    = inflow_disturbance_begin
-       ENDIF
-       IF ( bc_ns == 'dirichlet/radiation' )  THEN
-          dist_nyn    = ny - inflow_disturbance_begin
-          dist_nys(1) = ny - inflow_disturbance_end
-       ELSEIF ( bc_ns == 'radiation/dirichlet' )  THEN
-          dist_nys    = inflow_disturbance_begin
-          dist_nyn(1) = inflow_disturbance_end
-       ELSEIF ( bc_ns == 'nested'  .OR.  bc_ns == 'nesting_offline' )  THEN
-          dist_nyn    = ny - inflow_disturbance_begin
-          dist_nys    = inflow_disturbance_begin
-       ENDIF
-    ENDIF
-
-!
-!-- A turbulent inflow requires Dirichlet conditions at the respective inflow boundary (so far, a
-!-- turbulent inflow is realized from the left side only).
-    IF ( turbulent_inflow  .AND.  bc_lr /= 'dirichlet/radiation' )  THEN
-       message_string = 'turbulent_inflow = .T. requires a Dirichlet ' //                          &
-                        'condition at the inflow boundary'
-       CALL message( 'check_parameters', 'PA0133', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Turbulent inflow requires that 3d arrays have been cyclically filled with data from prerun in
-!-- the first main run
-    IF ( turbulent_inflow  .AND.  initializing_actions /= 'cyclic_fill'  .AND.                     &
-         initializing_actions /= 'read_restart_data' )  THEN
-       message_string = 'turbulent_inflow = .T. requires ' //                                      &
-                        'initializing_actions = ''cyclic_fill'' or ' //                            &
-                        'initializing_actions = ''read_restart_data'' '
-       CALL message( 'check_parameters', 'PA0055', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- In case of turbulent inflow
-    IF ( turbulent_inflow )  THEN
-
-!
-!--    Calculate the index of the recycling plane
-       IF ( recycling_width <= dx  .OR.  recycling_width >= nx * dx )  THEN
-          WRITE( message_string, * )  'illegal value for recycling_width: ', recycling_width
-          CALL message( 'check_parameters', 'PA0134', 1, 2, 0, 6, 0 )
-       ENDIF
-!
-!--    Calculate the index
-       recycling_plane = recycling_width / dx
-!
-!--   Check for correct input of recycling method for thermodynamic quantities
-       IF ( TRIM( recycling_method_for_thermodynamic_quantities ) /= 'turbulent_fluctuation'  .AND.&
-            TRIM( recycling_method_for_thermodynamic_quantities ) /= 'absolute_value' )  THEN
-          WRITE( message_string, * )  'unknown recycling method for thermodynamic quantities: ',   &
-               TRIM( recycling_method_for_thermodynamic_quantities )
-          CALL message( 'check_parameters', 'PA0184', 1, 2, 0, 6, 0 )
-       ENDIF
-
-    ENDIF
-
-
-    IF ( turbulent_outflow )  THEN
-!
-!--    Turbulent outflow requires Dirichlet conditions at the respective inflow boundary (so far, a
-!--    turbulent outflow is realized at the right side only).
-       IF ( bc_lr /= 'dirichlet/radiation' )  THEN
-          message_string = 'turbulent_outflow = .T. requires bc_lr = "dirichlet/radiation"'
-          CALL message( 'check_parameters', 'PA0038', 1, 2, 0, 6, 0 )
-       ENDIF
-!
-!--    The ouflow-source plane must lay inside the model domain
-       IF ( outflow_source_plane < dx  .OR.  outflow_source_plane > nx * dx )  THEN
-          WRITE( message_string, * )  'illegal value for outflow_source'// '_plane: ',             &
-                 outflow_source_plane
-          CALL message( 'check_parameters', 'PA0145', 1, 2, 0, 6, 0 )
-       ENDIF
+       IF ( inflow_disturbance_end < 0  .OR.  inflow_disturbance_end > ny )    &
+       THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters: inflow_disturbance',&
+                                    '_end out of range'
+          CALL local_stop
+       ENDIF
+    ENDIF
+
+    IF ( outflow_l )  THEN
+       dist_nxr    = nx - inflow_disturbance_begin
+       dist_nxl(1) = nx - inflow_disturbance_end
+    ELSEIF ( outflow_r )  THEN
+       dist_nxl    = inflow_disturbance_begin
+       dist_nxr(1) = inflow_disturbance_end
+    ELSEIF ( outflow_s )  THEN
+       dist_nyn    = ny - inflow_disturbance_begin
+       dist_nys(1) = ny - inflow_disturbance_end
+    ELSEIF ( outflow_n )  THEN
+       dist_nys    = inflow_disturbance_begin
+       dist_nyn(1) = inflow_disturbance_end
+    ENDIF
+
+!
+!-- Check random generator
+    IF ( random_generator /= 'system-specific'  .AND. &
+         random_generator /= 'numerical-recipes' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ check_parameters:'
+          PRINT*, '    unknown random generator: random_generator=', &
+                  random_generator
+       ENDIF
+       CALL local_stop
     ENDIF
 
@@ -2975,11 +2395,12 @@
 !-- Determine damping level index for 1D model
     IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
-       IF ( damp_level_1d == -1.0_wp )  THEN
+       IF ( damp_level_1d == -1.0 )  THEN
           damp_level_1d     = zu(nzt+1)
           damp_level_ind_1d = nzt + 1
-       ELSEIF ( damp_level_1d < 0.0_wp  .OR.  damp_level_1d > zu(nzt+1) )  THEN
-          WRITE( message_string, * )  'damp_level_1d = ', damp_level_1d, ' must be >= 0.0 and <= ',&
-                 zu(nzt+1), '(zu(nzt+1))'
-          CALL message( 'check_parameters', 'PA0136', 1, 2, 0, 6, 0 )
+       ELSEIF ( damp_level_1d < 0.0  .OR.  damp_level_1d > zu(nzt+1) )  THEN
+          IF ( myid == 0 )  PRINT*, '+++ check_parameters:  damp_level_1d=', &
+                                    damp_level_1d, ' must be > 0.0 and < ',  &
+                                    'zu(nzt+1)', zu(nzt+1)
+          CALL local_stop
        ELSE
           DO  k = 1, nzt+1
